#ifndef SR04_H
#define	SR04_H
//------------------------------------------------------------------------------
#include "SR04_Prototypes.h"
//------------------------------------------------------------------------------
int distn = 0;
//------------------------------------------------------------------------------
void SR04_init()
{
  TRIG_dir = 0;                 //RB0 as output PIN (TRIG)
  ECHO_dir = 1;                 //RB4 as Input PIN (ECHO)
  
  GIE = 1;                      //Global Interrupt Enable
  RBIF = 0;                     //Clear PORTB On-Change Interrupt Flag
  RBIE = 1;                     //Enable PORTB On-Change Interrupt
  
  T1CON = 0x10;                 //Initialize Timer Module (Prescaler = 2)
}
//------------------------------------------------------------------------------
void SR04_trigger()
{
  TMR1H = 0;                     //Sets the Initial Value of Timer
  TMR1L = 0;                     //Sets the Initial Value of Timer

  TRIG = 1;                      //TRIGGER HIGH
  __delay_us(10);                //10uS Delay
  TRIG = 0;                      //TRIGGER LOW 
}
//------------------------------------------------------------------------------
void __interrupt() echoTime()
{
  if(RBIF == 1)                      //Makes sure that it is PORTB On-Change Interrupt
  {
    RBIE = 0;                        //Disable On-Change Interrupt
    if(ECHO == 1)                    //If ECHO is HIGH
      TMR1ON = 1;                    //Start Timer
    if(ECHO == 0)                    //If ECHO is LOW
    {
      TMR1ON = 0;                    //Stop Timer
      distn = ((TMR1H<<8) | TMR1L )/58;  //Calculate Distance
    }
  }
  RBIF = 0;                     //Clear PORTB On-Change Interrupt flag
  RBIE = 1;                     //Enable PORTB On-Change Interrupt
}
//------------------------------------------------------------------------------
#endif